//*************************************************
//* WayBackButton was designed for Mozilla Firefox
//*  by Lazar Kovacevic, www.inverudio.com
//*
//* It detect 404 Error Page Not Found in the title tag of a page
//* Problems:
//* 404 Errors without these words in the title tags won't be detected
//* Detection will be false in the case that requested page is
//*   about 404 Error and not the 404 Error itself
//* However, these pages are not common in comparison 
//*   with the total number of pages
//* I may fix that in the future, or if you are a 
//*   developer with stronger JavaScript skills, please do so
//*************************************************

var waybackbutton = {
  init: function() {
    var appcontent = document.getElementById("appcontent");   // browser
    if(appcontent)
      appcontent.addEventListener("load", this.onPageLoad, true);
    var messagepane = document.getElementById("messagepane"); // mail
    if(messagepane)
      messagepane.addEventListener("load", this.onPageLoad, true);
  },

  onAddPageToFile: function() {
    var data = gBrowser.selectedBrowser.contentDocument.location.href;
    const id = "waybackbutton@lazar.kovacevic";
    var ext = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(id)
                    .getItemLocation(id); 
    var file = Components.classes["@mozilla.org/file/local;1"]
                     .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(ext.path);
    file.append("whitelist.txt");
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
    foStream.init(file, 0x02 | 0x10, 0664, 0); // write, create, truncate
    foStream.write(data+"\r\n", data.length+1);
    foStream.close();
  },

  onSearchPageInFile: function() {
    var data = gBrowser.selectedBrowser.contentDocument.location.href;
    const id = "waybackbutton@lazar.kovacevic";
    var ext = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(id)
                    .getItemLocation(id); 

    var file = Components.classes["@mozilla.org/file/local;1"]
                     .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(ext.path);
    file.append("whitelist.txt");
    
    var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                        .createInstance(Components.interfaces.nsIFileInputStream);
    istream.init(file, 0x01, 0664, 0);
    istream.QueryInterface(Components.interfaces.nsILineInputStream);
    var line = {}, hasmore;
    var pagefound = 'false'
    do {
      hasmore = istream.readLine(line);
      if(line.value==data || line.value==data+"\r\n")pagefound='true'; 
    } while(hasmore && pagefound=='false');
    istream.close();
    if (pagefound=='true'){}
    else {
            var stajebilo = confirm("'Page Not Found' was detected at '"+gBrowser.selectedBrowser.contentDocument.location.href+"'. Click 'Cancel' if this is an error and this warning will not appear in the future for this page, or click 'OK' to see archived version of the page.");
        if (stajebilo){
        	var tstr = "http://web.archive.org/~"+gBrowser.selectedBrowser.contentDocument.location.href;
        	tstr = tstr.replace(/~http:\/\//i, "");
        	tstr = tstr.replace(/~/i, "");
            gBrowser.selectedTab = gBrowser.addTab(tstr);
        }
        else {

            waybackbutton.onAddPageToFile();
            }
}
  },

  onPageLoad: function(aEvent) {
    var doc = aEvent.originalTarget; // doc is document that triggered "onload" event
    // do something with the loaded page.
    // doc.location is a Location object (see below for a link).
    // You can use it to make your code executed on certain pages only.
    //
    // Because I don't know javascript too well, and am ignorant of 
    //  case (in)sensitivity and regural expressions in JS
    //  I just did most obvious possibilities
    //	/19960101-re_/	old match now invalid!
    if(gBrowser.selectedBrowser.contentDocument.location.href.search("http://web.archive.org/web/") < 0){
      if(doc.title.search("404 -") > -1 || doc.title.search("HTTP 404 Not Found") > -1 || doc.title.search("HTTP 404 Error") > -1 || doc.title.search("404 Error") > -1 || doc.title.search("404 error") > -1 || doc.title.search("404 Not Found") > -1 || doc.title.search("404 Not found") > -1 || doc.title.search("404 not found") > -1 ||
 doc.title.search("404 File Not Found") > -1 ||doc.title.search("404 File Not found") > -1 || doc.title.search("404 Page Not Found") > -1 || doc.title.search("404 Page not found") > -1 || doc.title.search("File Not Found") > -1 || doc.title.search("File not found") > -1 || doc.title.search("Page Not Found") > -1 || doc.title.search("Page not found") > -1){
waybackbutton.onSearchPageInFile()
	}
    }
    else if(gBrowser.selectedBrowser.contentDocument.location.href.search("http://web.archive.org/web/19960101-re_/") > -1){
    	var tstr = gBrowser.selectedBrowser.contentDocument.location.href;
    	tstr = tstr.replace("web/19960101-re_/http://", "");
    	tstr = tstr.replace("web/19960101-re_/", "");
        gBrowser.selectedTab = gBrowser.addTab(tstr);
    }
  },
  onLoad: function() {
    // initialization code
    this.initialized = true;
    this.strings = document.getElementById("waybackbutton-strings");
  },
  onMenuItemCommand: function(e) {
    if(gBrowser.selectedBrowser.contentDocument.location.href.search("http://web.archive.org/web/") < 0){
    	var tstr = "http://web.archive.org/"+gBrowser.selectedBrowser.contentDocument.location.href;
    	gBrowser.selectedTab = gBrowser.addTab(tstr);
  }
    else if(gBrowser.selectedBrowser.contentDocument.location.href.search("http://web.archive.org/web/19960101-re_/") > -1){
    	var tstr = gBrowser.selectedBrowser.contentDocument.location.href;
    	tstr = tstr.replace("web/19960101-re_/http://", "*/");
    	tstr = tstr.replace("web/19960101-re_/", "*/");
        gBrowser.selectedTab = gBrowser.addTab(tstr);
    }
    else {
    	var tstr = "http://web.archive.org/*/"+gBrowser.selectedBrowser.contentDocument.location.href;
        gBrowser.selectedTab = gBrowser.addTab(tstr);
    }
},
  onToolbarButtonCommand: function(e) {
    // just reuse the function above.  you can change this, obviously!
    waybackbutton.onMenuItemCommand(e);
  }

};
window.addEventListener("load", function(e) { waybackbutton.onLoad(e); }, false);

window.addEventListener("load", function() { waybackbutton.init(); }, false);

<toolbarpalette id="BrowserToolbarPalette">
  <toolbarbutton id="waybackbutton-button" class="toolbarbutton-1"
    label="&toolbarbutton.label;" tooltiptext="&toolbarbutton.tooltip;"
    oncommand="waybackbutton.onToolbarButtonCommand(event);"/>
</toolbarpalette>

